#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include"dSFMT.h"


#define	dx		pow(10,-3)	//width of box
#define	N1		10000		//the number of random number
#define	N2		10000		//the numebr of trial

dsfmt_t dsfmt1;				//random number
double min =-10.0;			//lower limit of PDF
double max =10.0;			//upper limit od PDF


double rand_cauchy(double x0 , double gamma){	//rand: cauchy
	double x = dsfmt_genrand_close_open(&dsfmt1);
	double y = x0 + gamma * tan( M_PI * (x - 0.5) );
	return y;
}

void PDF_normal_limit( double *data , int data_num ,double data_min , int imax , double *output){	//PDF with limit
	int i ;
	
	for( i=0 ; i<data_num ; i++ ){
		if( data[i] >= min && data[i] <= max){
			output[(int)( ( data[i] - data_min )/dx) ] += 1.0/data_num;
		}
	}
	for( i=0 ; i<imax ; i++){
		output[i] /= dx;
	}
}

int double_comp(const void *_a, const void *_b) {	//for qsort
	double a = *(double *)_a;
	double b = *(double *)_b;
	
	if (a > b)		return -1;
	else if (a < b)	return 1;
	else			return 0;
}


int main(void){
	
	//Seed of random number
	dsfmt_init_gen_rand(&dsfmt1,1);
	
	int i, j;
	double *rand ,*ave , *med , *F_ave , *F_med ;
	rand = (double *)calloc( N1 , sizeof(double) );
	ave  = (double *)calloc( N2 , sizeof(double) );
	med  = (double *)calloc( N2 , sizeof(double) );
	int imax;
	FILE *fpave , *fpmed;
	if( (fpave = fopen("average.dat","w") ) ==NULL){
		printf("FILE Error : average\n");
		exit(1);
	}
	if( (fpmed = fopen("median.dat","w")) == NULL){
		printf("FILE Error : median\n");
		exit(1);
	}
	
	
	for( i=0; i<N2 ; i++){	//trial
		for( j=0; j<N1; j++){	//generate the random number
			rand[j] = rand_cauchy(0.0 ,1.0);
			ave[i] += rand[j]/N2;
		}
		qsort( rand , N1 ,sizeof(double),double_comp);
		med[i] = ( rand[(N1/2)-1] + rand[(N1/2)] )/2.0;
	}
	
	//PDF with limit
	imax = (int)( ( max - min )/dx ) + 1;
	F_ave = (double * )calloc( imax , sizeof(double) );
	F_med = (double * )calloc( imax , sizeof(double) );
	PDF_normal_limit( ave , N2 , min , imax , F_ave );
	PDF_normal_limit( med , N2 , min , imax , F_med );//
	
	for(i=0;i<imax;i++){
		fprintf( fpave , "%f %f\n", min+(i+0.5)*dx ,F_ave[i]);
		fprintf( fpmed , "%f %f\n", min+(i+0.5)*dx ,F_med[i]);
	}
	
	fclose(fpave);
	fclose(fpmed);
	free(rand);
	free(ave);
	free(med);
	free(F_ave);
	free(F_med);
	
	return 0;
}



